<?php
/*!
 * Copyright goodsmore <http://goodsmore.net/>
 * version 1.52
 * Dual licensed under the MIT or GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 */

if ( ! function_exists('ajax_load') ) {
	function ajax_load( $selectors , $option , $search_parameter )
	{
		$value = array() ;

		$GLOBALS[ 'search_parameter' ] = $search_parameter ;
		$GLOBALS[ 'GroupItemOption' ]  = groupitem_option( $option ) ;
		list( $result , $requests , $vars , $callback ) = get_requests( $search_parameter ) ;
		if ( ! $result ) die( 'illegal access.' ) ;
		if ( ! empty ( $result ) ) switch( true ) {
			case ( ! empty ( $requests[ 'id' ] ) && empty( $requests[ 'type' ] ) ) :
				$value = array(
					'item_data'      => get_item_xml( $requests[ 'id' ] ) ,
					'selectors'      => $selectors ,
					'option'         => $GLOBALS[ 'GroupItemOption' ] ,
					'sozai_width'    => intval( MOSHIMO_SOZAI_WIDTH )  ,
					'sozai_id'       => MOSHIMO_SOZAI_ID ,
					'sozai_addclass' => MOSHIMO_SOZAI_ADDCLASS ,
					'sozai_duration' => intval( MOSHIMO_SOZAI_DURATION )  ,
					'review_limit'   => ( defined( 'REVIEW_LIMIT' ) && $v = intval( REVIEW_LIMIT ) ) ? $v : 5 ,
					'now_printing'   => ( defined( 'NOW_PRINTING' ) && NOW_PRINTING !== '' ) ? NOW_PRINTING : 'images/now_printing.jpg' ,
				) ;
				break ;
			case ( ! empty ( $requests[ 'id' ] ) && $requests[ 'type' ] === 'get_review' ) :
				$value = get_review( $requests ) ;
				break ;
			case ( ! empty ( $requests[ 'id' ] ) && $requests[ 'type' ] === 'get_reason' ) :
				$value = get_reason( $requests ) ;
				break ;
			case ( ! empty ( $requests[ 'id' ] ) && $requests[ 'type' ] === 'get_group' ) :
				$value = get_group( $requests ) ;
				break ;
			case ( $requests[ 'type' ] === 'ranking' && intval( RANKING_LIMIT ) > 0 ) :
			case ( $requests[ 'type' ] === 'search' && intval( SEARCH_LIMIT ) > 0 ) :
				$value = get_items( $requests, $vars ) ;
				break ;
		}
		$json_value	= json_encode( $value ) ;
		if ( function_exists( 'mb_http_output' ) ) {
			mb_http_output( 'pass' ) ;
		}
		$mtype	= ( ! empty( $callback ) ) ? 'text/javascript' : 'application/json' ;
		header( 'Content-Type: ' . $mtype . ' ; charset=utf-8' ) ;
		if ( empty( $callback ) ) header( 'X-Content-Type-Options: nosniff' ) ;
		echo ( ! empty( $callback ) ) ? $callback . '(' . $json_value . ');' : $json_value ;
	}
}

if ( ! function_exists('get_requests') ) {
	function get_requests( $search_parameter )
	{
		global $GroupItemOption ;
		$array = $vars = array() ;
		$result = false ;

		mb_language( 'Japanese' ) ;
		$requests_int   = array( 'id' , 'offset' , 'rate' , 'per_page' , 'summary_len' , 'groupitem_col' ) ;
		$requests_type  = array( 'type' ) ;
		$requests_text  = array( 'word' , 'tag' , 'category' , 'title' , 'sortorder' ) ;
		$requests_Jsonp = array( 'callback' , 'password' , 'host' ) ;
		$review_sort    = array( 'sort' ) ;
		$check_key      = array( 'id' , 'word' , 'tag' , 'category' ) ;

		foreach( $requests_int as $key ) {
			$array[ $key ] = ( ! empty( $_GET[ $key ] ) ) ? intval( @$_GET[ $key ] ) : 0 ;
		}
		foreach( $requests_type as $key ) {
			$array[ $key ] = ( ! empty( $_GET[ $key ] ) ) ? trim( convert_to_utf( stripSlashesGPC( @$_GET[ $key ] ) ) ) : '' ;
		}
		if ( empty( $array[ 'id' ] ) ) {
			foreach( $requests_text as $key ) {
				$array[ $key ] = ( ! empty( $_GET[ $key ] ) ) ? trim( convert_to_utf( stripSlashesGPC( @$_GET[ $key ] ) ) ) : '' ;
			}
			$vars              = get_search_parameter( $search_parameter ) ;
			$array[ 'except' ] = get_except_words() ;
		}
		if ( $array[ 'type' ] === 'get_review' ) foreach( $review_sort as $key ) {
			$array[ $key ] = ( ! empty( $_GET[ $key ] ) ) ? trim( convert_to_utf( stripSlashesGPC( @$_GET[ $key ] ) ) ) : '' ;
		}
		foreach( $requests_Jsonp as $key ) {
			$$key = ( ! empty( $_GET[ $key ] ) ) ? trim( stripSlashesGPC( @$_GET[ $key ] ) ) : '' ;
		}
		switch ( ! empty( $callback ) ) {
			case true :
				if ( ! checkJsonp( $password , $host ) ) return array( $result , $array , $vars , $callback ) ;
				break ;
			case false :
				if ( ! isAjax() ) return array( $result , $array , $vars , $callback ) ;
				break ;
		}
		foreach( $check_key as $key ) {
			if ( ! empty( $array[ $key ] ) ) {
				$result = true ;
				break ;
			}
		}
		$GLOBALS[ 'summary_length' ] = ( ! empty( $array[ 'summary_len' ] ) ) ? $array[ 'summary_len' ] : ( ( defined( 'SUMMARY_LEN' ) ) ? intval( SUMMARY_LEN ) : 100 ) ;
		$GLOBALS[ 'groupitem_col' ]  = ( ! empty( $array[ 'groupitem_col' ] ) ) ? $array[ 'groupitem_col' ] : ( ( $v = intval( $GroupItemOption['GroupItemCol'] ) ) ? $v :  4 ) ;
		return array( $result , $array , $vars , $callback ) ;
	}
}

if ( ! function_exists('get_search_parameter') ) {
	function get_search_parameter( $search_parameter )
	{
		if ( ! function_exists( 'array_intersect_key' ) ) {
			require_once( 'class/upgrade.php' ) ;
		}
		$replace  = array() ;
		$requests = ( $v = array_intersect_key( $_GET , $search_parameter ) ) ? $v : array() ;
		$texts    = array( 'has_shop_price' , 'field' , 'jan_code' , 'start_date_from' , 'start_date_to' ) ;
		foreach ( $requests as $key => $v ) {
			$replace[ $key ] = ( in_array( $key , $texts ) ) ? trim( convert_to_utf( stripSlashesGPC( $v ) ) ) : intval( $v ) ;
		}
		return array_merge( $search_parameter , $replace ) ;
	}
}

if ( ! function_exists('get_except_words') ) {
	function get_except_words()
	{
		$words = ( ! empty( $_GET['except_words'] ) ) ? trim( stripSlashesGPC( @$_GET['except_words'] ) ) : ( ( EXCEPT_WORDS !== '' ) ? trim( EXCEPT_WORDS ) : '' ) ;
		$array = ( ! empty( $words ) ) ? array_filter( array_map( 'trim' , explode( ' ' , $words ) ) , 'strlen' ) : array() ;
		return ( ! empty( $array ) ) ? ' -' . implode( ' -' , array_map( 'convert_to_utf' , $array ) ) : '' ;
	}
}

if ( ! function_exists('groupitem_option') ) {
	function groupitem_option( $option )
	{
		$option  = array_map( 'convert_to_utf' , $option ) ;
		$option['GroupItemCol'] = ( $v = intval( $option['GroupItemCol'] ) ) ? $v : 4 ;
		return $option ;
	}
}

if ( ! function_exists('fetch_url') ) {
	function fetch_url( $url , $params = array() , $method = 'GET' , $options = array() )
	{
		$default = array(
			'curl'      => true ,
			'timeout'   => 30 ,
			'useragent' => 'PHP/' . phpversion() ,
		) ;
		$OPTIONS = ( ! empty ( $options ) ) ? array_merge( $default , (array)$options ) : $default ;
		foreach ( $OPTIONS as $key => $v ) {
			$$key = $v ;
		}
		switch ( true ) {
			case ( ! $curl ) :
			case ( ! function_exists('curl_init') ) :
			 	include_once( 'class/snoopy.php' ) ;
				$snoopy = new Snoopy() ;
				$snoopy->proxy_host  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_HOST : '' ;
				$snoopy->proxy_port  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PORT : 8080 ;
				$snoopy->proxy_user  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_USER : '' ;
				$snoopy->proxy_pass  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PASS : '' ;
				if ( ! empty ( $timeout ) ) $snoopy->_fp_timeout = $timeout ;
				$snoopy->agent       = ( ! empty ( $useragent ) ) ? $useragent : 'PHP/' . phpversion() ;
				$data                = ( $method === 'GET' && ! empty ( $params ) ) ? http_query( $params ) : '' ;
				$url                 = ( $method === 'GET' && ! empty ( $data ) ) ? $url . '?' . $data : $url ;
				$result              = ( $method === 'POST' && ! empty ( $params ) ) ? $snoopy->submit( $url, $params ) : $snoopy->fetch( $url ) ;
				$body                = $snoopy->results ;
				$status              = ( ! empty ( $snoopy->response_code ) ) ? explode( ' ', $snoopy->response_code , 3 ) : array() ;
				$http_code           = ( ! empty ( $status[1] ) ) ? (int)$status[1] : 0 ;
				$rs                  = ( $result && $http_code == 200 ) ? true : false ;
				$response_code       = $snoopy->response_code ;
				$error               = $snoopy->error ;
				$lastredirectaddr    = $snoopy->lastredirectaddr ;
				break ;
			default :
				$data          = ( ! empty ( $params ) ) ? http_query( $params ) : '' ;
				$url           = ( $method === 'GET' && ! empty ( $data ) ) ? $url . '?' . $data : $url ;
				$proxy_port    = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PORT : 8080 ;
				$proxy_userpwd = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' && defined( 'PROXY_USER' ) && PROXY_USER !== '' ) ? PROXY_USER . ':' . PROXY_PASS : false ;
				$curl = curl_init( $url ) ;
				if( $method == 'POST' ) {
					curl_setopt( $curl , CURLOPT_POST , true ) ;
					curl_setopt( $curl , CURLOPT_POSTFIELDS , $data ) ;
				}
				curl_setopt( $curl , CURLOPT_HEADER , true ) ;
				curl_setopt( $curl , CURLOPT_RETURNTRANSFER , true ) ;
				curl_setopt( $curl , CURLOPT_SSL_VERIFYPEER , false ) ;
				curl_setopt( $curl , CURLOPT_SSL_VERIFYHOST , false ) ;
				if ( ! empty ( $timeout ) ) {
					curl_setopt( $curl , CURLOPT_TIMEOUT, $timeout ) ;
				}
				curl_setopt( $curl , CURLOPT_FAILONERROR , false ) ;
				if ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) {
					curl_setopt( $curl , CURLOPT_PROXY , PROXY_HOST . ':' . $proxy_port ) ;
					curl_setopt( $curl , CURLOPT_PROXYUSERPWD , $proxy_userpwd ) ;
				}
				if ( ! empty ( $useragent ) ) {
					curl_setopt( $curl , CURLOPT_USERAGENT , $useragent ) ;
				}
				$response         = curl_exec( $curl ) ;
				$header_size      = ( ! empty ( $response ) ) ? curl_getinfo( $curl, CURLINFO_HEADER_SIZE ) : 0 ;
				$header           = ( ! empty ( $response ) ) ? substr( $response , 0 , $header_size ) : null ;
				$body             = ( ! empty ( $response ) ) ? substr( $response , $header_size ) : null ;
				$error            = curl_error( $curl ) ;
				$errno            = curl_errno( $curl ) ;
				$http_code        = curl_getinfo( $curl , CURLINFO_HTTP_CODE ) ;
				$lastredirectaddr = curl_getinfo( $curl , CURLINFO_EFFECTIVE_URL ) ;
				curl_close( $curl ) ;
				$rs = ( ! empty( $body ) && $http_code === 200 ) ? true : false ;
				list( $response_code ) = explode( "\n", $header , 2 ) ;
				//list( $response_code ) = preg_split( '#(\r\n|\r|\n){2}#' , $header, 2 , PREG_SPLIT_NO_EMPTY ) ;
		}
		return array( $body , $rs , $response_code , $error , $lastredirectaddr , $http_code ) ;
	}
}

if ( ! function_exists('fetch_multi_url') ) {
	function fetch_multi_url( $urls , $options = array() ) {
		$body = $rs = $response_code = $error = $http_code = array() ;
		$default = array(
			'timeout'   => 30 ,
			'useragent' => 'PHP/' . phpversion() ,
		) ;
		$OPTIONS = ( ! empty ( $options ) ) ? array_merge( $default , (array)$options ) : $default ;
		switch ( true ) {
			case ( ! function_exists( 'curl_multi_init' ) ) :
				foreach ( $urls as $i => $url ) {
					$arr = fetch_url( $url , array() , 'GET' , $OPTIONS ) ;
					$body[ $i ]          = $arr[ 0 ] ;
					$rs[ $i ]            = $arr[ 1 ] ;
					$response_code[ $i ] = $arr[ 2 ] ;
					$error[ $i ]         = $arr[ 3 ] ;
					$http_code[ $i ]     = $arr[ 5 ] ;
				}
				break ;
			default :
				foreach ( $OPTIONS as $key => $v ) {
					$$key = $v ;
				}
				$proxy_port    = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PORT : 8080 ;
				$proxy_userpwd = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' && defined( 'PROXY_USER' ) && PROXY_USER !== '' ) ? PROXY_USER . ':' . PROXY_PASS : false ;
				$mh            = curl_multi_init() ;
				if ( function_exists('curl_multi_setopt') ) {
					curl_multi_setopt( $mh , CURLMOPT_PIPELINING , true ) ;
				}
				foreach ( $urls as $i => $url ) {
					$conn[$i] = curl_init( $url ) ;
					curl_setopt( $conn[$i], CURLOPT_HEADER , true ) ;
					curl_setopt( $conn[$i], CURLOPT_RETURNTRANSFER , true ) ;
					curl_setopt( $conn[$i], CURLOPT_SSL_VERIFYPEER , false ) ;
					curl_setopt( $conn[$i], CURLOPT_SSL_VERIFYHOST , false ) ;
					curl_setopt( $conn[$i], CURLOPT_FAILONERROR , false ) ;
					if ( ! empty ( $timeout ) ) {
						curl_setopt( $conn[$i] ,CURLOPT_TIMEOUT , $timeout ) ;
					}
					if ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) {
						curl_setopt( $conn[ $i ], CURLOPT_PROXY , PROXY_HOST . ':' . $proxy_port ) ;
						curl_setopt( $conn[ $i ], CURLOPT_PROXYUSERPWD , $proxy_userpwd ) ;
					}
					if ( ! empty ( $useragent ) ) {
						curl_setopt( $conn[ $i ], CURLOPT_USERAGENT , $useragent ) ;
					}
					curl_multi_add_handle( $mh , $conn[$i] ) ;
				}
				$active = null ;
				do {
					$mrc = curl_multi_exec( $mh , $active ) ;
				} while ( $mrc == CURLM_CALL_MULTI_PERFORM ) ;
		
				while ( $active && $mrc == CURLM_OK ) {
					if ( curl_multi_select( $mh ) == -1 ) { 
						usleep( 100 ) ;
					}
					do $mrc = curl_multi_exec( $mh, $active ) ;
					while ( $mrc == CURLM_CALL_MULTI_PERFORM ) ;
				}
				foreach ( $urls as $i => $url ) {
					$response          = curl_multi_getcontent( $conn[$i] )  ;
					$header_size       = ( ! empty ( $response ) ) ? curl_getinfo( $conn[$i], CURLINFO_HEADER_SIZE ) : 0 ;
					$header            = ( ! empty ( $response ) ) ? substr( $response, 0, $header_size ) : null ;
					$body[$i]          = ( ! empty ( $response ) ) ? substr( $response, $header_size ) : null ;
					$http_code[$i]     = curl_getinfo( $conn[$i] , CURLINFO_HTTP_CODE ) ;
					$rs[$i]            = ( ! empty( $response ) && $http_code[$i] === 200 ) ? true : false ;
					$error[$i]         = curl_error( $conn[$i] ) ;
					list( $_response ) = explode( "\n", $header , 2 ) ;
					$response_code[$i] = $_response ;
					curl_multi_remove_handle( $mh , $conn[$i] ) ;
					curl_close( $conn[$i] ) ;
				}
				curl_multi_close( $mh ) ;
		}
		return array( $body , $rs , $response_code , $error , $http_code ) ;
	}
}

if ( ! function_exists('http_query') ) {
	function http_query( $params , $arg_separator = '&' , $numeric_prefix = '' )
	{
		if( ! function_exists( 'http_build_query' ) ) {
			require_once( 'class/upgrade.php' ) ;
		}
		return ( ! empty ( $params ) ) ? http_build_query( $params , $numeric_prefix , $arg_separator ) : '' ;
	}
}

if ( ! function_exists('get_html') ) {
	function get_html( $id )
	{
		$target = make_item_request( $id , 'html' ) ;
		list( $html , $results ) = fetch_url( $target ) ;
		return ( ! empty ( $results ) ) ? convert_to_utf( $html ) : '' ;
	}
}

if ( ! function_exists('return_xml') ) {
	function return_xml( $req , $id = 0 , $get_json = true )
	{
		list( $xml , $results , $response , $error ) = fetch_url( $req ) ;
		$status = ( ! empty ( $id ) ) ? responseLog( $response , $error , $id ) : true ;
		switch ( true ) {
			case ( $get_json === true && extension_loaded( 'json' ) ) :
				return ( ! empty ( $results ) && $status ) ? replace_wave_dash( json_decode( $xml , true ) ) : array() ;
			case ( function_exists( 'simplexml_load_string' ) ) :
				return ( ! empty ( $results ) && $status ) ? simplexml_load_string( replace_wave_dash( deleteControlCode( $xml ) ) ) : array() ;
			default :
	 			include_once( 'class/xml.php' ) ;
				return ( ! empty ( $results ) && $status ) ? XML_unserialize( replace_wave_dash( deleteControlCode( $xml ) ) ) : array() ;
		}
	}
}

if ( ! function_exists('responseLog') ) {
	function responseLog( $response , $error , $id )
	{
		if( ! function_exists( 'array_replace' ) ) {
			require_once( 'class/upgrade.php' ) ;
		}
		$file   = dirname( __FILE__ ) . '/cache/response.log' ;
		$array  = ( file_exists( $file ) ) ? file( $file ) : array() ;
		$status = ( ! empty ( $response ) ) ? array_replace( explode( ' ' , $response , 3 ), array( $id ) ) : array( $id ) ;
		if ( ! empty ( $error ) ) array_push( $status , $error ) ;
		array_unshift( $array , '[' . date_ex( 'Y n j G:i:s' ) . '] '. implode( ',' , $status ) ) ;
		if ( cacheDirCheck() && $fp = @fopen( $file , 'wb' ) ) {
			fputs( $fp , join( "\n" , array_map( 'deleteControlCode' , limitArray( $array ) ) ) ) ;
			fclose( $fp ) ;
		}
		return ( $status[1] === '200' ) ? true : false ;
	}
}

if ( ! function_exists('request_count') ) {
	function request_count( $c = 1 )
	{
		$file  = dirname( __FILE__ ) . '/cache/request_count.log' ;
		$array = ( file_exists( $file ) && $v = file( $file ) ) ? array_map( 'trim' , $v ) : array() ;
		$count = ( empty( $array ) ) ? $c : ( ( is_digit( $array[0] ) && date_compare( $array[0] , '-60 second' , '<' ) ) ? $c : count( $array ) + $c ) ;
		if ( $count == $c ) $array = array() ;
		for ( $i = 0 ; $i < $c ; $i++ ) {
			array_push( $array , time_ex() ) ;
		}
		if ( cacheDirCheck() && $fp = @fopen( $file , 'wb' ) ) {
			fputs( $fp , join( "\n" , array_map( 'deleteControlCode' , $array ) ) ) ;
			fclose( $fp ) ;
		}
		return $count ;
	}
}

if ( ! function_exists('get_xml') ) {
	function get_xml( $req , $id = 0 , $key= 'ArticleSearch' , $get_json = true )
	{
		if ( request_count() > 90 ) return array() ;
		$xml = return_xml( $req , $id , $get_json ) ;
		switch ( is_object( $xml ) ) {
			case true :
				return ( ! empty ( $xml ) ) ? obj2array( $xml->children() ) : array() ;
			default :
				return ( ! empty ( $xml ) ) ? $xml[ $key ] : array() ;
		}
	}
}

if ( ! function_exists('get_multi_xml') ) {
	function get_multi_xml( $urls , $article_id = 0 , $log_key = null , $html_key = null , $get_json = true )
	{
		$count = ( ! empty( $html_key ) && isset( $urls[ $html_key ] ) ) ? count( $urls ) - 1 : count( $urls ) ;
		if ( request_count( $count ) > 90 ) return array() ;
		$ret = array() ;
		list( $body , $rs , $response_code , $error , $http_code ) = fetch_multi_url( $urls ) ;
		foreach ( $urls as $i => $url ) {
			$status = ( ! empty( $log_key ) && $i === $log_key ) ? responseLog( $response_code[ $i ] , $error[ $i ] , $article_id ) : true ;
			$ret[ $i ] = ( ! empty( $html_key ) && $i === $html_key && $rs[ $i ] ) ?  convert_to_utf( $body[ $i ] ) : ( ( $rs[ $i ] ) ? xml_to_array( $body[ $i ] , $get_json ) : array() ) ;
		}
		return $ret ;
	}
}

if ( ! function_exists('get_multi_url') ) {
	function get_multi_url( $urls , $timeout = 30 )
	{
		$body = $rs = $response_code = $error = $http_code = array() ;
		if ( request_count( count( $urls ) ) > 90 ) return array( $body , $rs , $response_code , $error , $http_code ) ;
		return fetch_multi_url( $urls , $timeout ) ;
	}
}

if ( ! function_exists('xml_to_array') ) {
	function xml_to_array( &$value , $get_json = true )
	{
		switch ( true ) {
			case ( $get_json === true && extension_loaded( 'json' ) ) :
				$ret = ( ! empty ( $value ) ) ? replace_wave_dash( json_decode( $value , true ) ) : array() ;
				return ( ! empty ( $ret ) ) ? reset( $ret ) : array() ;
			case ( function_exists( 'simplexml_load_string' ) ) :
				$xml = ( ! empty( $value ) ) ? simplexml_load_string( replace_wave_dash( deleteControlCode( $value ) ) ) : null ;
				return ( is_object( $xml ) && ! empty ( $xml ) ) ? obj2array( $xml->children() ) : array() ;
			default :
	 			include_once( 'class/xml.php' ) ;
				$ret = ( ! empty ( $value ) ) ? XML_unserialize( replace_wave_dash( deleteControlCode( $value ) ) ) : array() ;
				return ( ! empty ( $ret ) ) ? reset( $ret ) : array() ;
		}
	}
}

if ( ! function_exists('obj2array') ) {
	function obj2array( &$xml )
	{
		$ret = array() ;
		switch ( true ) {
			case ( is_string( $xml ) ) :
				return $xml ;
			default :
				$array = ( is_object( $xml ) ) ? get_object_vars( $xml ) : ( ( is_array( $xml ) ) ? $xml : array() ) ;
				if ( ! empty( $array ) ) foreach ( $array as $key => $v ) {
					$ret[ $key ] = ( ! empty ( $v ) ) ? obj2array( $v ) : '' ;
				}
				return $ret ;
		}
	}
}

if ( ! function_exists('make_item_request') ) {
	function make_item_request( $article_id , $type = 'search' , $groupid = null , $limit = null , $start = null )
	{
		if ( $type === 'html' ) {
			$url = 'http://mp.moshimo.com/article/' . $article_id ;
			$params = array(
				'shop_id' => MOSHIMO_SHOP_ID ,
			) ;
			return $url . '?' . http_query( $params ) ;
		}
		$url = 'http://api.moshimo.com/article/' ;
		$params = array(
			'authorization_code' => AUTHORIZATION_CODE ,
			'article_id'         => ( empty ( $groupid ) ) ? $article_id : null ,
		) ;
		switch ( $type ) {
			case 'search' :
				$query = ( (int)DEFINE_CATEGORY == 1 ) ? 'search' : 'search2' ;
				$params[ 'require_tag_list' ] = 1 ;
				break;
			case 'review' :
			case 'reason' :
				$query = $type ;
				$params[ 'article_group_include_flag' ] = 1 ;
				$params[ 'sort_order' ]                 = 'newly' ;
				break;
			case 'material' :
				$query = $type ;
				break;
			case 'groupitem' :
				global $search_parameter ;
				$query = ( (int)DEFINE_CATEGORY == 1 ) ? 'search' : 'search2' ;
				$params[ 'article_group_id' ] = $groupid ;
				$params[ 'list_per_page' ]    = $limit ;
				$params[ 'require_tag_list' ] = 1 ;
				$params[ 'page_index' ]       = $start ;
				foreach ( $search_parameter as $key => $value ) {
					if ( ! empty( $value ) || $key === 'stock_status' ) $params[ $key ] = $value ;
				}
				break;
			default :
				return false ;
		}
		$format = ( extension_loaded( 'json' ) ) ? '.json' : '.xml' ;
		return $url . $query . $format . '?' . http_query( $params ) ;
	}
}

if ( ! function_exists('make_category_request') ) {
	function make_category_request( $category_code = null )
	{
		$mosimo_category = ( (int)DEFINE_CATEGORY == 1 ) ? 'list': 'list2' ;
		$url = 'http://api.moshimo.com/category/' . $mosimo_category ;
		$params = array(
			'authorization_code'    => AUTHORIZATION_CODE ,
			'article_category_code' => $category_code ,
		) ;
		$format = ( extension_loaded( 'json' ) ) ? '.json' : '.xml' ;
		return $url . $format . '?' . http_query( $params ) ;
	}
}

if ( ! function_exists('get_item_xml') ) {
	function get_item_xml( $id )
	{
		$array = $urls = $multi = array() ;
		if ( $data = readCache( $id, 'details' ) ) {
			$array = $data ;
		} else {
			$req = make_item_request( $id ) ;
			switch ( true ) {
				case ( ! function_exists( 'curl_multi_init' ) ) :
					$article_key = ( (int)DEFINE_CATEGORY == 1 ) ? 'ArticleSearch': 'ArticleSearch2' ;
					$xml         = get_xml( $req , $id , $article_key ) ;
					break ;
				default:
					$urls = array(
						'article'  => $req ,
						'review'   => make_item_request( $id , 'review' ) ,
						'reason'   => make_item_request( $id , 'reason' ) ,
						'material' => make_item_request( $id , 'material' ) ,
						'html'     => make_item_request( $id , 'html' ) ,
					) ;
					$multi = get_multi_xml( $urls , $id , 'article' , 'html' ) ;
					$xml   = ( ! empty( $multi[ 'article' ] ) ) ? reset( $multi ) : array() ;
			}
			$rows  = ( ! empty( $xml['Rows'] ) ) ? intval( $xml['Rows'] ) : 0 ;
			switch ( true ) {
				case ( ! empty( $rows ) ) :
					$array = make_item_cache( $xml , $multi , $id ) ;
					break ;
				default:
					$html  = ( ! empty( $multi[ 'html' ] ) ) ? end( $multi ) : null ;
					$array = getStockStatusWord( $array , $id , $html ) ;
			}
		}
		if ( ! empty( $array ) ) {
			unset( $array[ 'ReviewData' ] , $array[ 'ReasonData' ] , $array[ 'Ratings' ] ) ;
		}
		return replaceArray( $array ) ;
	}
}

if ( ! function_exists('make_item_cache') ) {
	function make_item_cache( &$xml , &$multi , $id )
	{
		$review = $reason = $material = $html = null ;
		$array  = reset( $xml['Articles'] ) ;
		$vars   = array( 'review' , 'reason' , 'material' , 'html' ) ;
		if ( ! empty( $multi ) ) foreach( $vars as $key ) {
			$$key = ( ! empty( $multi[ $key ] ) ) ? $multi[ $key ] : array() ;
		}
		$array = getaddArray( $array , $id ,  1 , $html ) ;
		list( $GroupItem , $GroupItemRows , $GroupNav ) = getGroupItem( $array , $id ) ;
		$array['GroupItem']     = $GroupItem ;
		$array['GroupItemRows'] = $GroupItemRows ;
		$array['GroupNav']      = $GroupNav ;
		$array['Material']      = getSozai( $array , $id , $material ) ;
		list( $ReviewRows , $ReviewData ) = getReviewData( $id , $review ) ;
		$array['ReviewRows'] = $ReviewRows ;
		$array['ReviewData'] = $ReviewData ;
		if ( ! empty( $ReviewRows ) ) list( $average , $chart , $ratings ) = getAverage( $array , $id ) ;
		$array['Average']     = ( ! empty( $ReviewRows ) ) ? $average : '' ;
		$array['ReviewChart'] = ( ! empty( $ReviewRows ) ) ? $chart : '' ;
		$array['Ratings']     = ( ! empty( $ReviewRows ) ) ? $ratings : array() ;
		$array['Review']      = ( ! empty( $ReviewRows ) ) ? getReview( $array , $id ) : '' ;
		if ( empty( $array['CatchCopy'] ) ) $array['CatchCopy'] = getPhrases( $array ) ;
		list( $ReasonRows , $ReasonData ) = getReasonData( $id , $reason ) ;
		$array['ReasonRows'] = $ReasonRows ;
		$array['ReasonData'] = $ReasonData ;
		$array['Reason']     = ( ! empty( $ReasonRows ) ) ? getReason( $array, $id ) : '' ;
		makeCache( $array , $id , 'details' ) ;
		return $array ;
	}
}

if ( ! function_exists('getPhrases') ) {
	function getPhrases( $array )
	{
		$text = ( ! empty( $array['SpecialDescription'] ) ) ? trim( $array['SpecialDescription'] ) : trim( $array['Description'] ) ;
		switch ( true ) {
			case ( strpos( $text, '<br />' ) === false ) :
				$str = $text ;
				break ;
			default :
				$arr= explode( '<br />' , $text ) ;
				$str = ( ! preg_match( '#(特徴|特長|説明|：)$#i', $arr[0] ) && mb_strlen( $arr[0] , 'UTF-8' ) > 3 ) ? $arr[0] : ( ( ! empty( $arr[1] ) ) ? $arr[1] : '' ) ;
				if ( empty( $str ) ) return '' ;
		}
		$split = preg_split( '#(。|｡|!|！|♪|☆)#' , toShow( strip_tags( $str ) ) , 2 , PREG_SPLIT_NO_EMPTY | PREG_SPLIT_DELIM_CAPTURE ) ;
		$ret   = ( count( $split ) == 3 ) ? $split[ 0 ] . $split[ 1 ] : reset( $split ) ;
		if ( preg_match( '#^(●|■|□|・|･|○|[\d]+\.)(.*?)$#i', $ret , $match ) ) $ret = ( ! empty( $match[2] ) ) ? $match[2] : $ret ;
		return  ( $v = trim( $ret ) ) ? item_substr( $v , 150 ) : '' ;
	}
}

if ( ! function_exists('getDiscountRate') ) {
	function getDiscountRate( $array )
	{
		$fixedprice = intval( $array['FixedPrice'] ) ;
		$shopprice  = intval( $array['ShopPrice'] ) ;
		$off        = ( ! empty( $fixedprice ) && ( $fixedprice - $shopprice ) > 0 ) ? number_format( ( ( $fixedprice - $shopprice ) / $fixedprice ) * 100 ) : 0 ;
		switch ( $off >= intval( LOWER_LIMIT_DISCOUNTRATE ) ) {
			case true :
				return array( $off.'%' , getDiscount( $array ) ) ;
			case false :
				return array( '' , '' ) ;
		}
	}
}

if ( ! function_exists('getDiscount') ) {
	function getDiscount( $array )
	{
		$fixedprice = intval( $array['FixedPrice'] ) ;
		$shopprice  = intval( $array['ShopPrice'] ) ;
		return ( ! empty( $fixedprice ) && ( $fixedprice - $shopprice ) > 0 ) ? $fixedprice - $shopprice : '' ;
	}
}

if ( ! function_exists('getFreeCarriage') ) {
	function getFreeCarriage( $array , $id , $html = null )
	{
		switch ( true ) {
			case ( (int)$array['IsFreeShipping'] == 1 )	:
				$ret = convert_to_utf( FREECARRIAGE ) ;
				break ;
			case ( (int)$array['ShopPrice'] < 8000 ) :
				$rs   = null ;
				$html = ( empty( $html ) ) ? get_html( $article_id ) : $html ;
				if ( ! empty( $html ) ) switch ( true ) {
					case ( extension_loaded( 'dom' ) ) :
						$rs = html_query( $html , '//p[@class="free-shipping red"]' ) ;
						break ;
					default :
						$free = array() ;
						preg_match( '#<p class="free-shipping red">(.*?)</p>#' , $html , $free ) ;
						$rs = ( ! empty( $free ) ) ? trim( end( $free ) ) : null ;
				}
				$ret = ( ! empty( $rs ) ) ? convert_to_utf( str_replace( array( '&lt;', '&gt;'	) , array( '', '' ) , toShow( strip_tags( $rs ) ) ) ) : '' ;
				break ;
		}
		return $ret ;
	}
}

if ( ! function_exists('html_query') ) {
	function html_query( $html , $query , $use_tagname = false , $dom = null , $return_dom = false )
	{
		switch ( true ) {
			case ( is_object( $dom ) ) :
				$rs = true ;
				break ;
			default :
				$dom = new DOMDocument() ;
				$rs  = @$dom->loadHTML( convert_to_html_entities( $html ) ) ;
		}
		$dom->preserveWhiteSpace = false ;
		switch ( true ) {
			case ( $use_tagname === true ) :
				$nodes = ( $rs ) ? $dom->getElementsByTagName( $query ) : null ;
				break ;
			default :
				$xpath = ( $rs ) ? new DOMXPath( $dom ) : null ;
				$nodes = ( is_object( $xpath ) ) ? $xpath->query( $query ) : null ;
				break ;
		}
		$item  = ( is_object( $nodes ) && is_object( $nodes->item(0) ) ) ? $nodes->item(0) : null ;
		$ret   = ( is_object( $item ) && ! empty( $item->nodeValue ) ) ? entityDecode( trim( $item->nodeValue ) ) : null ;
		return ( $return_dom === true ) ? array( $ret , $dom ) : $ret ;
	}
}

if ( ! function_exists('getDeliveryGuide') ) {
	function getDeliveryGuide( $array )
	{
		switch ( true ) {
			case ( (int)$array['PreorderFlag'] == 1 ) :
				return convert_to_utf( PREORDERFLAG ) ;
			case ( (int)$array['IsDeliverySameday'] == 1 ) :
				return convert_to_utf( ISDELIVERYSAMEDAY ) ;
			default :
				$guide = (int)$array['DodFrom'] ;
				if ( (int)$array['DodFrom'] == 0 ) $guide = convert_to_utf( ISDELIVERYSAMEDAY ) ;
				if ( (int)$array['DodTo'] != (int)$array['DodFrom'] ) $guide .= '&#65374;'. (int)$array['DodTo'] . convert_to_utf( DELIVERYGUIDE ) ;
				else if ( (int)$array['DodFrom'] != 0 ) $guide .= convert_to_utf( DELIVERYGUIDE ) ;
				return convert_to_utf( $guide ) ;
		}
	}
}

if ( ! function_exists('getBundle') ) {
	function getBundle( $array )
	{
		return ( (int)$array['BundleImpossible'] == 1 ) ? convert_to_utf( BUNDLE ) : '' ;
	}
}

if ( ! function_exists('getPayment') ) {
	function getPayment( $array )
	{
		switch( intval( $array['PaymentType'] ) ) {
			case 1 :
				return  convert_to_utf( PAYMENT_TYPE1 ) ;
			case 3 :
				return  convert_to_utf( PAYMENT_TYPE2 ) ;
		}
	}
}

if ( ! function_exists('getNewly') ) {
	function getNewly( $array )
	{
		return ( (int)$array['IsNewly'] == 1 ) ? convert_to_utf( NEWLY ) : '' ;
	}
}

if ( ! function_exists('getIsHeavySeller') ) {
	function getIsHeavySeller( $array )
	{
		return ( (int)$array['HeavySeller'] == 1 ) ? convert_to_utf( ISHEAVYSELLER ) : '' ;
	}
}

if ( ! function_exists('getNewIcon') ) {
	function getNewIcon( $array )
	{
		return ( (int)$array['IsNewly'] == 1 ) ? '<img src="'. NEW_ICON. '" alt="">'  : '' ;
	}
}

if ( ! function_exists('getPopIcon') ) {
	function getPopIcon( $array )
	{
		return ( (int)$array['HeavySeller'] == 1 ) ? '<img src="'. POP_ICON . '" alt="">'  : '' ;
	}
}

if ( ! function_exists('getFreeCarriageIcon') ) {
	function getFreeCarriageIcon( $array )
	{
		return ( (int)$array['IsFreeShipping'] == 1 ) ? '<img src="'. FREECARRIAGE_ICON . '" alt="">'  : '' ;
	}
}

if ( ! function_exists('getStockStatusWord') ) {
	function getStockStatusWord( $array , $id = 0 , $html = null )
	{
		if( ! empty( $id ) ) {
			$array = array() ;
			$html  = ( empty( $html ) ) ? get_html( $id ) : $html ;
			$str   = ( strpos( $html , 'finish-search' ) !== false ) ? convert_to_utf( SELLOUT ) : '' ;
			if( ! empty( $str ) ) $array['StockStatusWord'] = $str ;
			return $array ;
		} else {
			return ( intval( $array['StockStatus'] ) == 0 ) ? convert_to_utf( OUTOFSTOCK ) : $array['StockStatusWord'] ;
		}
	}
}

if ( ! function_exists('getSozai') ) {
	function getSozai( $array , $article_id , $xml = null )
	{
		$string = '' ;
		$itemArray = $urls = array() ;
		$i = 1 ;
		if ( ! defined( 'USE_X_IMAGE' ) ) define( 'USE_X_IMAGE', true ) ;
		switch ( true ) {
			case ( $array['HasMaterial'] == 1 ) :
				if( is_null( $xml ) ) {
					$req = make_item_request( $article_id , 'material' ) ;
					$xml = get_xml( $req, 0, 'ArticleMaterial' ) ;
				}
				$rows = intval( $xml['Rows'] ) ;
				if( ! empty( $rows ) ) switch( true ) {
					case ( ! empty( $xml['Materials']['Material'][0] ) && is_array( $xml['Materials']['Material'][0] ) ) :
						$itemArray = $xml['Materials']['Material'] ;
						break ;
					case ( ! empty( $xml['Materials'] ) && is_array( $xml['Materials'] ) ) :
						$itemArray = $xml['Materials'] ;
						break ;
				}
				break ;
			case ( USE_X_IMAGE === true ) :
				$count = ( ! empty( $array['ImageCount'] ) ) ? intval( $array['ImageCount'] ) : 0 ;
				$code  = ( ! empty( $array['ImageCode'] ) ) ? trim( $array['ImageCode'] ) : '' ;
				for ( $n = 1 ; $n <= $count ; $n++ ) {
					$urls[ $n ] = 'http://image.moshimo.com/item_image/' . $code . '/' . $n . '/x.jpg' ;
				}
				list( $body, $results ) = fetch_multi_url( $urls ) ;
				foreach( $results as $key => $rs ) {
					if( $rs ) $itemArray[] = array(
						'Type' => 1 ,
						'Data' => $urls[ $key ] ,
					) ;
				}
				break ;
		}
		if( ! empty( $itemArray ) ) foreach ( $itemArray as $item ) {
			$type = ( ! empty ( $item['Type'] ) ) ? intval( $item['Type'] ) : 0 ;
			if ( $type == 0 ) continue ;
			switch( true ) {
				case ( $type == 5 ) :
					$string .= $item['Data'] ;
					break ;
				default :
					$string .= '<img id="'.MOSHIMO_SOZAI_ID.$i.'"src="'.toShow( $item['Data'] ) .'" />' ;
					break ;
			}
			$i++ ;
		}
		return $string ;
	}
}

if ( ! function_exists('get_review') ) {
	function get_review( $requests )
	{
		foreach ( $requests as $key=>$value ){
			$$key = $value ;
		}
		$string = '' ;
		if ( $array = readCache( $id , 'details' ) ) {
			$string = ( ! empty( $array['ReviewRows'] ) ) ? getReview( $array , $id , $offset , $rate , $sort , $per_page ) : '' ;
		}
		return $string ;
	}
}

if ( ! function_exists('get_reason') ) {
	function get_reason( $requests )
	{
		foreach ( $requests as $key=>$value ){
			$$key = $value ;
		}
		$string = '' ;
		if ( $array = readCache( $id, 'details' ) ) {
			$string = ( ! empty( $array['ReasonRows'] ) ) ? getReason( $array , $id , $offset , $per_page ) : '' ;
		}
		return $string ;
	}
}

if ( ! function_exists('get_group') ) {
	function get_group( $requests )
	{
		foreach ( $requests as $key=>$value ){
			$$key = $value ;
		}
		$ret = array() ;
		if ( $array = readCache( $id, 'details' ) ) {
			global $GroupItemOption ;
			$arr = array() ;
			switch ( empty( $offset ) ) {
				case true :
					$GroupItem     = ( ! empty( $array['GroupItem'] ) ) ? $array['GroupItem'] : array() ;
					$GroupItemRows = ( ! empty( $array['GroupItemRows'] ) ) ? intval( $array['GroupItemRows'] ) : 0 ;
					$GroupNav      = ( ! empty( $array['GroupNav'] ) ) ? $array['GroupNav'] : '' ;
					break ;
				case false :
					list( $GroupItem , $GroupItemRows , $GroupNav ) = getGroupItem( $array , $id , $offset ) ;
					break ;

			}
			if ( ! empty( $GroupItemRows ) && ! empty( $GroupItem ) ) foreach ( $GroupItem as $key => $v ) {
				$arr[ $key ] = replaceArray( $v ) ;
			}
			$ret = array(
				'GroupItem'     => $arr ,
				'GroupItemRows' => $GroupItemRows ,
				'GroupNav'      => $GroupNav ,
				'option'        => $GroupItemOption ,
				'now_printing'  => ( defined( 'NOW_PRINTING' ) && NOW_PRINTING !== '' ) ? NOW_PRINTING : 'images/now_printing.jpg' ,
			) ;
		}
		return $ret ;
	}
}

if ( ! function_exists('getReviewData') ) {
	function getReviewData( $article_id , $xml = null )
	{
		$array = array() ;
		if( is_null( $xml ) ) {
			$req = make_item_request( $article_id , 'review' ) ;
			$xml = get_xml( $req , 0 , 'ArticleReview' ) ;
		}
		$rows =  ( ! empty ( $xml['Rows'] ) ) ? intval( $xml['Rows'] ) : 0 ;
		if( ! empty( $rows ) ) switch( true ) {
			case ( ! empty( $xml['Reviews']['Review'][0] ) && is_array( $xml['Reviews']['Review'][0] ) ) :
				$array = $xml['Reviews']['Review'] ;
				break ;
			case ( ! empty( $xml['Reviews'] ) && is_array( $xml['Reviews'] ) ) :
				$array = $xml['Reviews'] ;
				break ;
		}
		return array( $rows , $array ) ;
	}
}

if ( ! function_exists('getAverage') ) {
	function getAverage( $array , $article_id )
	{
		$chd = $chdl = $ratings = array() ;
		$string = '' ;
		if( ! empty( $array['ReviewRows'] ) ) {
			$ratings = ( ! empty( $array['ReviewData'] ) && $v = array_column( $array['ReviewData'] , 'Rating' ) ) ? array_map( 'intval' , $v ) : array() ;
			$rating  = ( ! empty( $ratings ) ) ? array_sum( $ratings ) : 0 ;
			$average = ( ! empty( $ratings ) ) ? round( $rating / $array['ReviewRows'] , 1 ) : 0 ;
			$width   = ( ! empty( $average ) ) ? round( 78 * ( $average / 5 ) ) : 0 ;
			$string = '
				<span class="bold red label">
					' . convert_to_utf( REVIEW_LABEL ) . '
				</span>
				<span class="average-block"></span>
				<span title="' . $average . convert_to_utf( '点' ) . '" class="review_average" style="width: ' . $width . 'px;"></span>
				<span class="bold red review-link">
					(' . $array['ReviewRows'] . convert_to_utf( '件の感想' ) . ')
				</span>
			' ;
			$count   = ( ! empty( $ratings ) ) ? array_count_values( $ratings ) : array() ;
			if ( ! empty( $count ) ) krsort( $count ) ;
			foreach ( $count as $key => $v ) {
				$chd[ $key ]  = round( ( $v / $array['ReviewRows'] ) * 100 ) ;
				$chdl[ $key ] = $v . ' ' . convert_to_utf( '件' ) ;
			}
			$url = 'http://chart.apis.google.com/chart' ;
			$params = array(
				'chs'  => '250x100' ,
				'cht'  => 'p3' ,
				'chd'  => 't:' . implode( ',' , array_values( $chd ) ) ,
				'chl'  => implode( '|', array_keys( $chd ) ) ,
				'chdl' => implode( '|' , array_values( $chdl ) ) ,
			) ;
			$chart = '<img src="' . $url . '?' . http_query( $params ) . '" alt="' . convert_to_utf( 'お客さまの評価' ) . '" title="' . convert_to_utf( 'お客さまの評価' ) . '" />' ;
		}
		return array( $string , $chart , $ratings ) ;
	}
}

if ( ! function_exists('getReviewArr') ) {
	function getReviewArr( $array , $limit , $offset , $rate , $sort )
	{
		$ret  = ( ! empty( $array[ 'ReviewData' ] ) ) ? $array[ 'ReviewData' ] : array() ;
		$date = ( empty( $rate ) && in_array( $sort , array( 'date_asc' , 'rate_desc' , 'rate_asc' ) ) && $v = array_column( $ret , 'CreatedAt' ) ) ? $v : array() ;
		switch ( true ) {
			case ( empty( $ret ) ) :
				return array() ;
			case ( ! empty( $rate ) ) :
				if ( ! function_exists( 'array_intersect_key' ) ) {
					require_once( 'class/upgrade.php' ) ;
				}
				$keys = ( $v = array_intersect( $array[ 'Ratings' ] , (array)$rate ) ) ? preserve_keys_slice( $v , $offset , $limit ) : array() ;
				return ( ! empty( $keys ) ) ? array_intersect_key( $ret , $keys ) : array() ;
			case ( $sort === 'date_asc' ) :
				array_multisort( $date , SORT_ASC , ( defined( 'SORT_NATURAL' ) ) ? SORT_NATURAL : SORT_STRING , $ret ) ;
				return array_slice( $ret , $offset , $limit ) ;
			case ( $sort === 'rate_desc' ) :
				array_multisort( $array[ 'Ratings' ] , SORT_DESC , SORT_NUMERIC , $date , SORT_DESC , ( defined( 'SORT_NATURAL' ) ) ? SORT_NATURAL : SORT_STRING , $ret ) ;
				return array_slice( $ret , $offset , $limit ) ;
			case ( $sort === 'rate_asc' ) :
				array_multisort( $array[ 'Ratings' ] , SORT_ASC , SORT_NUMERIC , $date , SORT_DESC , ( defined( 'SORT_NATURAL' ) ) ? SORT_NATURAL : SORT_STRING , $ret ) ;
				return array_slice( $ret , $offset , $limit ) ;
			default :
				return array_slice( $ret , $offset , $limit ) ;
		}
	}
}

if ( ! function_exists('getReview') ) {
	function getReview( $array , $article_id , $offset = 0 , $rate = 0 , $sort = 'date_desc' , $per_page = 0 )
	{
		$limit = ( ! empty( $per_page ) ) ? intval( $per_page ) : ( ( defined( 'REVIEW_LIMIT' ) && $v = intval( REVIEW_LIMIT ) ) ? $v : 5 ) ;
		$string = '' ;
		if( ! empty( $array['ReviewRows'] ) ) {
			$i = 0 ;
			$string .= '<table class="review-table" border="0" cellpadding="0" cellspacing="0">' ;
			$count   = ( ! empty( $array['Ratings'] ) ) ? array_count_values( $array['Ratings'] ) : array() ;
			if ( ! empty( $count ) ) krsort( $count ) ;
			$rows = ( empty( $rate ) ) ? $array['ReviewRows'] : ( ( ! empty( $count[ $rate ] ) ) ? $count[ $rate ] : 0 ) ;
			if ( $array['ReviewRows'] > 1 ) {
				$string .= '
					<tr>
						<td class="Nav Order" colspan="3">
							<ul class="PageNav ReviewSort" >
				' ;
				switch ( empty( $rate ) ) {
					case true :
						$string .= '
							<li class="rate corner-all">'.convert_to_utf( 'お客様の感想 ( ' . $rows . '件 )' ) .'</li>
							<li>'.ReviewOrder( $sort ).'</li>
						' ;
						break ;
					case false :
						$string .= '<li class="rate corner-all">'.convert_to_utf( '評価 ' . $rate .' の感想 ( ' . $rows . '件 )' ) .'</li>' ;
						break ;
				}
				$string .= '
								<li>'.ReviewPerpage( $rows ).'</li>
							</ul>
						</td>
					</tr>
				' ;
			}
			$itemArray = getReviewArr( $array , $limit , $offset , $rate , $sort ) ;
			foreach ( $itemArray as $item ) {
				$class = ( $i % 2 == 0 ) ? ' even' : ' odd' ;
				if ( $item['ArticleId'] != $article_id ) {
					$string .= '
						<tr>
							<td class="inline-left similar'.$class.'" colspan="3"><a href="'.itemUrl( intval( $item['ArticleId'] ) ).'">'.toShow( trim( $item['ArticleName'] ) ) .'</a></td>
						</tr>
					' ;
				}
				$string .= '
					<tr>
						<td class="inline-left star font-12'.$class.'">'.getStar( $item['Rating'] ).'</td>
						<td class="inline-left name'.$class.'"><span class="bold">'.getAetas( $item['Aetas'] ).' '.getGender( $item['Gender'] ).'</span></td>
						<td class="inline-left date'.$class.'">'.toShow( $item['CreatedAt'] ).'</td>
					</tr>
					<tr>
						<td class="inline-left review'.$class.'" colspan="3">'.nl2br( toShow( trim( $item['Text'] ) ) ).'</td>
					</tr>
				' ;
				$i++ ;
			}
			$class = ( $class == ' even' ) ? ' odd' : ' even' ;
			$string .= '<tr><td class="notice'.$class.'" colspan="3">'.convert_to_utf( REVIEW_NOTICE ) .'</td></tr>' ;
			if ( $array['ReviewRows'] > 1 && ( $rows > $limit || ! empty( $array['Ratings'] ) ) ) {
				$string .= '
					<tr>
						<td class="Nav" colspan="3">
				' ;
				if( ! empty( $array['Ratings'] ) ) {
					$string .= '<ul class="PageNav RateNav" >' ;
					$string .= ( empty( $rate ) ) ? '<li class="currentpage corner-all" title="'.convert_to_utf( $array['ReviewRows'] . '件' ) .'">'.convert_to_utf( '全て表示' ) .'</li>' : '<li><a class="corner-all" id="rating0" href="#" title="'.convert_to_utf( $array['ReviewRows'] . '件' ) .'">'.convert_to_utf( '全て表示' ) .'</a></li>' ;
					foreach ( $count as $key => $v ) {
						$string .= ( $rate ==  $key ) ? '<li class="currentpage corner-all" title="'.convert_to_utf( $v . '件' ) .'">'.convert_to_utf( '評価 ' . $key ) .'</li>' : '<li><a class="corner-all" id="rating'.$key.'" href="#" title="'.convert_to_utf( $v . '件' ) .'">'.convert_to_utf( '評価 ' . $key ) .'</a></li>' ;
					}
					$string .= '</ul>' ;
				}
				if ( $rows > $limit ) $string .= ReviewNav( $rows , $limit , $offset ) ;
				$string .= '
						</td>
					</tr>
				' ;
			}
			$string .= '</table>' ;
		}
		return $string ;
	}
}

if ( ! function_exists('ReviewOrder') ) {
	function ReviewOrder( $sort )
	{
		$vars = array(
			'date_desc' => convert_to_utf( '新しい順' ) ,
			'date_asc'  => convert_to_utf( '古い順' ) ,
			'rate_asc'  => convert_to_utf( '評価が低い順' ) ,
			'rate_desc' => convert_to_utf( '評価が高い順' ) ,
		) ;
		$str =  '<select id="review_order" class="">';
		foreach ( $vars as $key=>$v ) {
			$selected = ( $key == $sort ) ? ' selected="selected"' : '' ;
			$str .= '<option value="'.$key.'"'.$selected.' class="br">'.$v.'</option>';
		}
		$str .=  '</select>';
		return $str ;
	}
}

if ( ! function_exists('ReviewPerpage') ) {
	function ReviewPerpage( $found , $id = 'review_per_page' )
	{
		$n       = 1 ;
		$array   = array() ;
		$default = ( defined( 'REVIEW_LIMIT' ) && $v = intval( REVIEW_LIMIT ) ) ? $v : 5 ;
		$max     = ( $found > 99 ) ? 99 : $found ;
		$count   = count( page_num( $max ) ) ;
		$str =  '
			<select id="'.$id.'" class="">
				<optgroup label="'.convert_to_utf( '表示件数' ).'">
					<option value="'.$default.'" selected="selected">'.$default.'</option>
		';
		for ( $i = 1 ; $i <= $count ; $i++ ) {
			$value = ( $i !== $count ) ? $i * 10 : ( ( $max == 99 ) ? 100 : $max ) ;
			if ( $value <= $default || in_array( $value , $array ) ) continue ;
			$array[] = $value ;
			$class   = ( ( $n + 1 ) % 5 == 0 ) ? ' class="br"' : '' ;
			$str    .= '<option value="'.$value.'"'.$class.'>'.$value.'</option>';
			$n++ ;
		}
		$str .=  '
				</optgroup>
			</select>
		';
		return $str ;
	}
}

if ( ! function_exists('page_num') ) {
	function page_num( $found , $step = 10 )
	{
		return range( 0 , intval( floor( $found / $step ) ) ) ;
	}
}

if ( ! function_exists('ReviewNav') ) {
	function ReviewNav( $found , $limit , $offset , $id = 'ReviewNav' , $prev_page='Prev' , $next_page='Next' , $class='PageNav' )
	{
 		$pagenav = '' ;
		if ( $found > $limit ) {
	 		include_once( 'class/PageNav.php' ) ;
			$PageNav = new PageNav( $found , $limit , $offset ) ;
			$pagenav = $PageNav->renderId( 3 , $id , $prev_page , $next_page , $class ) ;
		}
		return $pagenav ;
	}
}

if ( ! function_exists('getStar') ) {
	function getStar( $rating )
	{
		$string  = '' ;
		$rating  = ( (int)$rating < 1 ) ? 1 : ( ( (int)$rating > 5 ) ? 5 : (int)$rating ) ;
		$string .= str_repeat( convert_to_utf( '★' ) , $rating ) ;
		$string .= ( $v = 5 - $rating ) ? str_repeat( convert_to_utf( '☆' ) , $v ) : '' ;
		return $string ;
	}
}

if ( ! function_exists('getAetas') ) {
	function getAetas( $aetas )
	{
		switch( $aetas ) {
			case '0' :
				return convert_to_utf( '10歳未満' ) ;
			default :
				return convert_to_utf( $aetas . '代' ) ;
		}
	}
}

if ( ! function_exists('getGender') ) {
	function getGender( $gender )
	{
		switch( $gender ) {
			case '1' :
				return convert_to_utf( '男性' ) ;
			case '2' :
				return convert_to_utf( '女性' ) ;
		}
	}
}
if ( ! function_exists('getReasonData') ) {
	function getReasonData( $article_id , $xml = null )
	{
		$array = array() ;
		if( is_null( $xml ) ) {
			$req = make_item_request( $article_id , 'reason' ) ;
			$xml = get_xml( $req , 0 , 'ArticleReason' ) ;
		}
		$rows =  ( ! empty ( $xml['Rows'] ) ) ? intval( $xml['Rows'] ) : 0 ;
		if( ! empty( $rows ) ) switch( true ) {
			case ( ! empty( $xml['Reasons']['Reason'][0] ) && is_array( $xml['Reasons']['Reason'][0] ) ) :
				$array = $xml['Reasons']['Reason'] ;
				break ;
			case ( ! empty( $xml['Reasons'] ) && is_array( $xml['Reasons'] ) ) :
				$array = $xml['Reasons'] ;
				break ;
		}
		return array( $rows , $array ) ;
	}
}

if ( ! function_exists('getReason') ) {
	function getReason( $array , $article_id , $offset = 0 , $per_page = 0 )
	{
		$limit = ( ! empty( $per_page ) ) ? intval( $per_page ) : ( ( defined( 'REVIEW_LIMIT' ) && $v = intval( REVIEW_LIMIT ) ) ? $v : 5 ) ;
		$string = '' ;
		if( ! empty( $array['ReasonRows'] ) ) {
			$i = 0 ;
			$rows = $array['ReasonRows'] ;
			$string .= '
				<table class="reason-table" border="0" cellpadding="0" cellspacing="0">
					<tr>
						<td class="Nav Order" colspan="2">
							<ul class="PageNav ReviewSort" >
								<li class="rate corner-all">' . convert_to_utf( '商品を購入した理由 ( ' . $rows . '件 )' ) . '</li>
								<li>' . ReviewPerpage( $rows, 'reason_per_page' ) . '</li>
							</ul>
						</td>
					</tr>
			' ;
			$itemArray = array_slice( $array['ReasonData'] , $offset , $limit ) ;
			foreach ( $itemArray as $item ) {
				$class = ( $i % 2 == 0 ) ? ' even' : ' odd' ;
				if ( $item['ArticleId'] != $article_id ) {
					$string .= '
						<tr>
							<td class="inline-left similar'.$class.'" colspan="2"><a href="'.itemUrl( intval( $item['ArticleId'] ) ).'">'.toShow( trim( $item['ArticleName'] ) ) .'</a></td>
						</tr>
					' ;
				}
				$string .= '
					<tr>
						<td class="inline-left name'.$class.'"><span class="bold">'.getAetas( $item['Aetas'] ).' '.getGender( $item['Gender'] ).'</span></td>
						<td class="inline-left date'.$class.'">'.toShow( $item['CreatedAt'] ).'</td>
					</tr>
					<tr>
						<td class="inline-left review'.$class.'" colspan="2">'.nl2br( toShow( trim( $item['Text'] ) ) ).'</td>
					</tr>
				' ;
				$i++ ;
			}
			$next = $offset + $limit ;
			if ( $rows > $limit ) $string .= '
				<tr>
					<td class="Nav" colspan="2">'.ReviewNav( $rows , $limit , $offset , 'ReasonNav' ).'</td>
				</tr>
			' ;
			$string .= '</table>' ;
		}
		return $string ;
	}
}

if ( ! function_exists('formatPrice') ) {
	function formatPrice( $val )
	{
		return convert_to_utf( sprintf( convert( PRICE_FORMAT ) , number_format( $val ) ) ) ;
	}
}

if ( ! function_exists('formatDiscountRate') ) {
	function formatDiscountRate( $val )
	{
		return convert_to_utf( sprintf( convert( DISCOUNTRATE_FORMAT ) , str_replace(  ' off' , '' , $val ) ) ) ;
	}
}

if ( ! function_exists('formatDiscount') ) {
	function formatDiscount( $val )
	{
		$price = ( strpos( $val , ',' ) === false ) ? number_format( $val ) : $val ;
		return convert_to_utf( sprintf( convert( DISCOUNT_FORMAT ) , $price ) ) ;
	}
}

if ( ! function_exists('formatDate') ) {
	function formatDate( $val )
	{
		return convert_to_utf( date_ex( convert( DATE_FORMAT ) , trim( $val ) ) ) ;
	}
}

if ( ! function_exists('getGroupItem') ) {
	function getGroupItem( $items , $article_id , $offset = 0 )
	{
		$array = $itemArray = $params = array() ;
		$found = $i = 0 ;
		$pagenav = '' ;
		$groupid = ( ! empty( $items['GroupId'] ) ) ? intval( $items['GroupId'] ) : 0 ;
		if ( ! empty( $groupid ) ) {
			global $groupitem_col ;
			$limit       = $groupitem_col * 2 ;
			$req         = make_item_request( $article_id , 'groupitem' , $groupid , $limit , $offset ) ;
			$article_key = ( (int)DEFINE_CATEGORY == 1 ) ? 'ArticleSearch': 'ArticleSearch2' ;
			$xml         = get_xml( $req , 'group_items' , $article_key ) ;
			$rows        = ( ! empty( $xml['Rows'] ) ) ? intval( $xml['Rows'] ) : 0 ;
			$found       = ( ! empty( $xml['Found'] ) ) ? intval( $xml['Found'] ) : 0 ;
			if( ! empty( $rows ) ) switch( true ) {
				case ( ! empty( $xml['Articles']['Article'][0] ) && is_array( $xml['Articles']['Article'][0] ) ) :
					$itemArray = $xml['Articles']['Article'] ;
					break ;
				case ( ! empty( $xml['Articles'] ) && is_array( $xml['Articles'] ) ) :
					$itemArray = $xml['Articles'] ;
					break ;
			}
			if( ! empty( $itemArray ) ) foreach ( $itemArray as $item ) {
				$id          = intval( $item['ArticleId'] ) ;
				$array[ $i ] = getaddArray( $item , $id , 0 ) ;
				$array[ $i ]['ItemHref'] = itemUrl( $id ) ;
				$i++ ;
			}
			$pagenav = ( $found > $limit ) ? ReviewNav( ceil( $found / $limit ) , 1 , $offset, 'GroupNav' ) : '' ;
		}
		return array( $array , $found , $pagenav ) ;
	}
}

if ( ! function_exists('getCatchCopy') ) {
	function getCatchCopy( $array )
	{
		$searches = $replacements = array() ;
		$searches = array( 
			'#(")+#sU',
		) ;
		$replacements = array( 
			'',
		) ;
		return preg_replace( $searches , $replacements , $array['CatchCopy'] ) ;
	}
}

if ( ! function_exists('getSummary') ) {
	function getSummary( $array )
	{
		global $summary_length ;
		return item_substr( toShow( trim( strip_tags( $array['Description'] ) ) ) , $summary_length ) ;
	}
}

if ( ! function_exists('item_substr') ) {
	function item_substr( $string , $length = 80 , $etc = '...', $encoding = 'UTF-8' )
	{
		if ( $length == 0 ) return '';
		if ( strlen( $string ) > $length ) {
		 	$length -= strlen( $etc ) ;	
			return mb_strcut( $string , 0 , $length , $encoding ) . $etc ;
		} else
			return $string ;
	}
}

if ( ! function_exists('getTag') ) {
	function getTag( $array )
	{
		return ( empty( $array['Tags']['Tag'] ) ) ? array() : ( ( is_string( $array['Tags']['Tag'] ) ) ? array( $array['Tags']['Tag'] ) : $array['Tags']['Tag'] ) ;
	}
}

if ( ! function_exists('getaddArray') ) {
	function getaddArray( &$array , $id , $details = 1 , $html = null )
	{
		list( $DiscountRate , $Discount ) = getDiscountRate( $array ) ;
		$array['DiscountRate']     = $DiscountRate ;
		$array['Discount']         = $Discount ;
		$array['DeliveryGuide']    = getDeliveryGuide( $array ) ;
		$array['Bundle']           = getBundle( $array ) ;
		$array['Payment']          = getPayment( $array ) ;
		$array['Newly']            = getNewly( $array ) ;
		$array['IsHeavySeller']    = getIsHeavySeller( $array ) ;
		$array['NewIcon']          = getNewIcon( $array ) ;
		$array['PopIcon']          = getPopIcon( $array ) ;
		$array['FreeCarriageIcon'] = getFreeCarriageIcon( $array ) ;
		$array['CatchCopy']        = getCatchCopy( $array ) ;
		if ( ! extension_loaded( 'json' ) || isset( $array['Tags']['Tag'] ) ) $array['Tags'] = getTag( $array ) ;
		switch ( $details ) {
			case  1 :
				$array['FreeCarriage']    = getFreeCarriage( $array , $id , $html ) ;
				$array['StockStatusWord'] = getStockStatusWord( $array ) ;
				$array['CategoryName']    = ( (int)DEFINE_CATEGORY == 1 && ! empty( $array[ 'CategoryName' ] ) ) ? $array[ 'CategoryName' ] : ( ( ! empty( $array[ 'Category' ][ 'Name' ] ) ) ? $array[ 'Category' ][ 'Name' ] : '' ) ;
				$arr = ( ! empty( $array[ 'Category' ][ 'Parents' ] ) && ! isset( $array[ 'Category' ][ 'Parents' ][ 'Parent' ] ) ) ? $array[ 'Category' ][ 'Parents' ] : ( ( ! empty( $array[ 'Category' ][ 'Parents' ][ 'Parent' ] ) ) ? $array[ 'Category' ][ 'Parents' ][ 'Parent' ] : array() ) ;
				if ( (int)DEFINE_CATEGORY == 2 ) switch( true ) {
					case ( ! empty( $arr[ 'Name' ] ) ) :
						$array['ParentCategoryName'] = $arr[ 'Name' ] ;
						break ;
					case ( $v = count( $arr ) ) :
						$array['ParentCategoryName'] = $arr[ $v - 1 ][ 'Name' ] ;
						break ;
					default :
						$array['ParentCategoryName'] = '' ;
						break ;
				}
				$vars = array( 'Description' , 'SpecialDescription' , 'Spec' ) ;
				foreach ( $vars as $key ){
					$array[ $key ] = ( $v = trim( $array[ $key ] ) ) ? tidy_string( $v ) : '' ;
				}
				break ;
			case  0 :
				$array['FreeCarriage'] = ( (int)$array['IsFreeShipping'] == 1 ) ? convert_to_utf( FREECARRIAGE ) : '' ;
				break ;
		}
		return $array ;
	}
}

if ( ! function_exists('tidy_string') ) {
	function tidy_string( $html )
	{
		switch ( true ) {
			case ( empty( $html ) ) :
				return $html ;
			case ( strpos( str_replace( array( '<br />' , '<br>' ) , array( '' , '' ) , $html ) , '<' ) === false ) :
				return ( strpos( $html , 'http' ) === false ) ? $html : makeClickable( $html ) ;
			default :
				$html = ( strpos( $html , 'http' ) === false ) ? $html : makeClickable( $html ) ;
		}
		$config = array(
			'show-body-only' => true ,
			'output-xhtml'   => true ,
			'ascii-chars'    => false , 
			'wrap'           => 0
		) ;
		switch ( true ) {
			case ( function_exists( 'tidy_repair_string' ) && ! function_exists( 'tidy_setopt' ) ) :
				$ret = ( $v = tidy_repair_string( $html , $config , 'utf8' ) ) ? trim( $v ) : $html ;
				break ;
			case ( function_exists( 'tidy_repair_string' ) && function_exists( 'tidy_setopt' ) ) :
				foreach( $config as $key => $v ) {
					tidy_setopt( $key , $v ) ;
				}
				tidy_set_encoding( 'utf8' ) ;
				$ret = ( $v = tidy_repair_string( $html ) ) ? trim( $v ) : $html ;
				break ;
			case ( extension_loaded( 'dom' ) ) :
				$ret = tidy_string_by_dom( $html ) ;
				break ;
			default :
				$ret = $html ;
		}
		return $ret ;
	}
}

if ( ! function_exists('tidy_string_by_dom') ) {
	function tidy_string_by_dom( $html )
	{
		if ( empty( $html ) || extension_loaded( 'dom' ) === false ) return $html ;
		$dom = new DOMDocument() ;
		$rs  = @$dom->loadHTML( '<html><meta http-equiv="Content-Type" content="text/html; charset=UTF-8"><body>' . $html . '</body></html>' ) ;
		$dom->formatOutput = true ;
		if ( $rs ) switch ( true ) {
			case ( version_compare( PHP_VERSION, '5.3.6', '>=' ) ) :
				$str   = '' ;
				$body  = ( $v = $dom->getElementsByTagName( 'body' ) ) ? $v->item(0) : null ;
				$child = ( is_object( $body ) && $body->hasChildNodes() ) ? $body->childNodes : null ;
				if ( is_object( $child ) ) for ( $i = 0 ; $child->length > $i ; $i++ ) {
					$str .= $dom->saveHTML( $child->item( $i ) ) ;
				}
				$ret = ( ! empty( $str ) ) ? trim( entityDecode( $str ) ) : $html ;
				break ;
			default :
				$matches = array() ;
				$str     = ( $v = $dom->saveHTML() ) ? $v : null ;
				if ( ! empty( $str ) ) preg_match( '#<body>(?:<p>)?(.*?)(?:</p>)?</body>#si' , $str , $matches ) ;
				$ret = ( ! empty( $matches ) ) ? trim( entityDecode( end( $matches ) ) ) : $html ;
				break ;
		}
		return ( $rs ) ? str_replace( '<br>', '<br />' , $ret ) : $html ;
	}
}

if ( ! function_exists('makeClickable') ) {
	function makeClickable( $text )
	{
		$pattern = '`(^|[^\"\'])((?:https?|ftp):\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+)`u' ;
		return preg_replace_callback( $pattern , 'makeClickable_callback' , $text ) ;
	}
}

if ( ! function_exists('makeClickable_callback') ) {
	function makeClickable_callback( $matches )
	{
		return $matches[ 1 ] . '<a href="' . $matches[ 2 ] . '" target="_blank">' . item_substr( $matches[ 2 ] , 60 ) . '</a>';
	}
}

if ( ! function_exists('replaceArray') ) {
	function replaceArray( &$array )
	{
		$exceptions = array( 'Description' , 'SpecialDescription' , 'Spec' , 'CatchCopy' , 'DeliveryGuide' , 'Average' , 'Review' , 'Reason' , 'GroupNav' ) ;

		foreach ( $array as $key=>$val ){
			if ( is_array( $val ) ) {
				$array[ $key ] = replaceArray( $array[ $key ] ) ;
			} else if ( ! empty ( $val ) ) {
				if( ! in_array( $key , $exceptions ) && strpos( $val , '<img' ) === false ) $array[ $key ] = toShow( $val ) ;
				if ( strpos( $key , 'Price' ) > 0 ) $array[ $key ] = formatPrice( $val ) ;
				else if ( $key === 'DiscountRate' ) $array[ $key ] = formatDiscountRate( $val ) ;
			 	else if ( $key === 'Discount' )     $array[ $key ] = formatDiscount( $val ) ;
				else if ( $key === 'StartDate' )    $array[ $key ] = formatDate( $val ) ;
			} else if ( empty ( $val ) ) {
				if ( strpos( $key , 'Price' ) > 0 ) $array[ $key ] = '' ;
			}
		}
		if ( ! empty( $array['ArticleId'] ) ) $array['Summary'] = getSummary( $array ) ;

		return $array ;
	}
}

if ( ! function_exists('get_items') ) {
	function get_items( $requests, $search_parameter )
	{
		$array = $ret = array() ;
		foreach ( $requests as $key=>$value ){
			$$key = $value ;
		}
		$name =  ( ! empty( $word ) ) ? substr( md5( $word ) , -6 ) : ( ( ! empty( $tag ) ) ? substr( md5( $tag ) , -6 ) : $category ) ;
		$order =  ( $type == 'ranking' ) ? '' : ( ( ! empty( $sortorder ) ) ? $sortorder : SEARCH_SORT_ORDER ) ;
		$cache_id =  $name.'_'.$order ;
		if ( $data = readCache( $cache_id, $type ) ) {
			$array = $data ;
		} else {
			$array = make_items_cache( $type , $word , $tag , $category , $except , $order , $search_parameter , $cache_id ) ;
		}
		if ( empty( $array ) ) return array() ;
		else foreach ( $array as $key => $v ) {
			$ret[ $key ] = replaceArray( $v , $feed ) ;
		}
		$option =  array(
			'title'        => ranking_title( $type , $title , getCategoryName( $category ) , $word , $tag ) ,
			'len'          => ( $type == 'ranking' ) ? intval( RANKING_LEN ) : intval( SEARCH_LEN ) ,
			'imageSize'    => ( $type == 'ranking' ) ? RANKING_IMAGESIZE : SEARCH_IMAGESIZE ,
			'addkey'       => ( $type == 'ranking' ) ? RANKING_ADDKEY : SEARCH_ADDKEY ,
			'addclass'     => ( $type == 'ranking' ) ? RANKING_ADDCLASS : SEARCH_ADDCLASS ,
			'col'          => ( $type == 'ranking' ) ? intval( RANKING_COL ) : intval( SEARCH_COL ) ,
			'duration'     => ( $type == 'ranking' ) ? intval( RANKING_DURATION ) : intval( SEARCH_DURATION ) ,
			'now_printing' => ( defined( 'NOW_PRINTING' ) && NOW_PRINTING !== '' ) ? NOW_PRINTING : 'images/now_printing.jpg' ,
		) ;
		return  array(
			'item_data' => ( ! empty ( $ret ) ) ? $ret : array() ,
			'option'    => $option ,

		) ;
	}
}

if ( ! function_exists('ranking_title') ) {
	function ranking_title( $type , $title , $categoryname , $word , $tag )
	{
		$vars  = array( 'title' , 'word' , 'tag' ) ;
		foreach ( $vars as $key ){
			$$key = ( ! empty( $$key ) ) ? convert( $$key ) : '' ;
		}
		$title    = ( ! empty( $title ) ) ? $title : ( ( $type == 'ranking' ) ? convert( RANKING_TITLE ) : convert( SEARCH_TITLE ) ) ;
		$name     = ( ! empty( $word ) ) ? $word : ( ( ! empty( $tag ) ) ? $tag : $categoryname ) ;
		$searches = array( '%s' , '%word' , '%tag' , '%category' ) ;
		$replace  = array( $name , $word , $tag , $categoryname ) ;
		return convert_to_utf( str_replace( $searches , $replace , $title ) ) ;
	}
}

if ( ! function_exists('make_items_cache') ) {
	function make_items_cache( $type , $word , $tag , $category , $except , $order , $search_parameter , $cache_id )
	{
		$array = $itemArray = array() ;
		$i               = 0 ;
		$mosimo_category = ( (int)DEFINE_CATEGORY == 1 ) ? 'search': 'search2' ;
		$article_key     = ( (int)DEFINE_CATEGORY == 1 ) ? 'ArticleSearch': 'ArticleSearch2' ;
		$url             = 'http://api.moshimo.com/article/' . $mosimo_category ;
		$params = array(
			'authorization_code' => AUTHORIZATION_CODE ,
			'require_tag_list'   => 1 ,
		) ;
		switch ( $type ) {
			case 'ranking':
				$params[ 'sort_order' ]    = 'sales' ;
				$params[ 'list_per_page' ] = intval( RANKING_LIMIT ) ;
				$params[ 'exists_stock' ]  = 1 ;
				break;
			case 'search':
				$params[ 'sort_order' ]    = $order ;
				$params[ 'list_per_page' ] = intval( SEARCH_LIMIT ) ;
				foreach ( $search_parameter as $key=>$value ){
					if ( ! empty( $value ) || $key === 'stock_status' ) $params[ $key ] = $value ;
				}
				break;
		}
		switch ( true )  {
			case ( ! empty ( $word ) && $except !== '' ) :
				$params[ 'words' ] = $word . $except ;
				break ;
			case ( ! empty ( $word ) ) :
				$params[ 'words' ] = $word ;
				break ;
			case ( ! empty ( $category ) && $except !== '' ) :
				$params[ 'words' ] = convert_to_utf( getCategoryName( $category ) ) . $except ;
				break ;
		}
		if ( ! empty( $category ) ) $params[ 'article_category_code' ] = $category ;
		if ( ! empty( $tag ) )      $params[ 'tags' ]                  = $tag ;
		$format = ( extension_loaded( 'json' ) ) ? '.json' : '.xml' ;
		$req = $url . $format . '?' . http_query( $params ) ;
		$xml = get_xml( $req, $type, $article_key ) ;
		$rows = intval( $xml['Rows'] ) ;
		if( ! empty( $rows ) ) switch( true ) {
			case ( ! empty( $xml['Articles']['Article'][0] ) && is_array( $xml['Articles']['Article'][0] ) ) :
				$itemArray = $xml['Articles']['Article'] ;
				break ;
			case ( ! empty( $xml['Articles'] ) && is_array( $xml['Articles'] ) ) :
				$itemArray = $xml['Articles'] ;
				break ;
		}
		if( ! empty( $rows ) ) foreach ( $itemArray as $item ) {
			$array[$i]  = $item ;
			$article_id = intval( $item['ArticleId'] ) ;
			$array[$i]  = getaddArray( $item, $article_id, 0 ) ;
			$array[$i]['ItemHref'] = itemUrl( $article_id ) ;
			$i++ ;
		}
		if ( ! empty( $array ) ) makeCache( $array , $cache_id , $type ) ;
		return $array ;
	}
}

if ( ! function_exists('getCategoryName') ) {
	function getCategoryName( $key )
	{
		$array = $urls = array() ;
		if ( $data = readCache( 'mosimo_category' , 'category' ) ) {
			switch ( empty ( $data[ $key ] ) ) {
				case true :
					$array = get_add_category( $key , $data ) ;
					makeCache( $array , 'mosimo_category' , 'category' ) ;
					break ;
				default :
					$array = $data ;
					break ;
			}
		} else {
			$req          = make_category_request() ;
			$categorylist = get_categorylist( $req ) ;
			$array        = make_category_array( $array , $categorylist ) ;
			foreach ( $array as $code => $v ) {
				$request = $req . '&article_category_code=' . $code;
				switch ( true ) {
					case ( ! function_exists('curl_multi_init') ) :
						$categorylist = get_categorylist( $request ) ;
						$array        = make_category_array( $array , $categorylist ) ;
						break ;
					default :
						$urls[] = $request ;
				}
			}
			if ( ! empty( $urls ) && function_exists('curl_multi_init') ) {
				list( $body , $rs , $response_code , $error , $http_code ) = get_multi_url( $urls ) ;
				foreach ( $urls as $i => $url ) {
					if ( ! empty( $rs[ $i ] ) ) {
						$categorylist = xml_to_array( $body[ $i ] ) ;
						$array        = make_category_array( $array , $categorylist ) ;
					}
				}
			}
			if ( empty ( $array[ $key ] ) ) $array = get_add_category( $key , $array ) ;
			makeCache( $array , 'mosimo_category' , 'category' ) ;
		}
		return ( ! empty ( $array ) ) ? $array[ $key ] : '' ;
	}
}

if ( ! function_exists('get_add_category') ) {
	function get_add_category( $key , &$array )
	{
		$req          = make_category_request( $key ) ;
		$categorylist = get_categorylist( $req ) ;
		$rows         = ( ! empty( $categorylist['Rows'] ) ) ? intval( $categorylist['Rows'] ) : 0 ;
		if ( ! empty( $rows ) ) $array[ $categorylist['Category']['Code'] ] = trim( convert( $categorylist['Category']['Name'] ) ) ;
		return $array ;
	}
}

if ( ! function_exists('get_categorylist') ) {
	function get_categorylist( $req )
	{
		$mosimo_category = ( (int)DEFINE_CATEGORY == 1 ) ? 'CategoryList': 'CategoryList2' ;
		$array           = get_xml( $req , 0 , $mosimo_category ) ;
		return ( ! empty ( $array ) ) ? $array : array() ;
	}
}

if ( ! function_exists('make_category_array') ) {
	function make_category_array( $array , $categorylist )
	{
		$rows = ( ! empty( $categorylist['Rows'] ) ) ? intval( $categorylist['Rows'] ) : 0 ;
		switch ( true ) {
			case ( (int)DEFINE_CATEGORY == 1 && ! empty( $categorylist['Categories'] ) && ! isset( $categorylist['Categories']['Category'] ) ) :
				$arr = $categorylist['Categories'] ;
				break ;
			case ( (int)DEFINE_CATEGORY == 1 && ! empty( $categorylist['Categories']['Category'] ) ) :
				$arr = $categorylist['Categories']['Category'] ;
				break ;
			case ( (int)DEFINE_CATEGORY == 2 && ! empty( $categorylist['Category']['Children'] ) && ! isset( $categorylist['Category']['Children']['Child'] ) ) :
				$arr = $categorylist['Category']['Children'] ;
				break ;
			case ( (int)DEFINE_CATEGORY == 2 && ! empty( $categorylist['Category']['Children']['Child'] ) ) :
				$arr = $categorylist['Category']['Children']['Child'] ;
				break ;
		}
		if ( ! empty( $rows ) ) foreach( $arr as $category ){
			$array[ $category['Code'] ] = trim( convert( $category['Name'] ) ) ;
		}
		return ( ! empty ( $array ) ) ? $array : array() ;
	}
}

if ( ! function_exists('itemUrl') ) {
	function itemUrl( $article_id )
	{
		switch( LINK_FORMAT === '' ) {
			case true :
				return make_item_request( $article_id , 'html' ) ;
				break;
			case false :
				return sprintf( LINK_FORMAT , $article_id ) ;
		}
	}
}

if ( ! function_exists('limitArray') ) {
	function limitArray( $array , $limit = 1000 )
	{
		$count = count( $array ) - $limit ;
		if( $count > 0 ) array_splice( $array , $limit , $count ) ;
		return $array ;
	}
}

if ( ! function_exists('makeCache') ) {
	function makeCache( $value , $cache_id , $group , $lifeTime = 0 )
	{
		if ( cacheDirCheck( $lifeTime ) ) {
			include_once( 'class/cache.php' ) ;
			$cache = new cache( $lifeTime ) ;
			$cache->save( $value , $cache_id , $group ) ;
		}
	}
}

if ( ! function_exists('readCache') ) {
	function readCache( $cache_id , $group , $time = false , $lifeTime = 0 )
	{
		include_once( 'class/cache.php' ) ;
		$cache = new cache( $lifeTime ) ;
		switch ( TEST_MODE == 1 ) {
			case true :
				$cache->clean( 'details' , 'notingroup' ) ;
				return null ;
			case false :
				return $cache->get( $cache_id , $group , $time ) ;
		}
	}
}

if ( ! function_exists('cacheDirCheck') ) {
	function cacheDirCheck( $lifeTime = 0 )
	{
		$result    = true ;
		$dir       = dirname( __FILE__ ) . '/cache/' ;
		$safe_mode = ini_get( 'safe_mode' ) ;
		if ( ! is_dir( $dir ) ) {
			if ( $safe_mode ) $result = false ;
			$mrs = mkdir( $dir , 0777 ) ;
			if ( ! $mrs ) $result = false ;
			else @chmod( $dir , 0777 ) ;
		}
		if ( ! is_writable( $dir ) || ! is_readable( $dir ) ) {
			$mrs = chmod( $dir , 0777 ) ;
			if ( ! $mrs ) $result = false ; ;
		}
		if ( is_writable( $dir ) && empty( $lifeTime ) ) removeCache( $lifeTime ) ;
		return $result ;
	}
}

if ( ! function_exists('removeCache') ) {
	function removeCache( $lifeTime = 0 , $automaticCleaningFactor = 20 )
	{
		if ( empty( $lifeTime ) && mt_rand( 1 , $automaticCleaningFactor ) == 1 ) {
			include_once( 'class/cache.php' ) ;
			if( ! function_exists( 'scandir' ) ) {
				require_once( 'class/upgrade.php' ) ;
			}
			$cache   = new cache( $lifeTime ) ;
			$dirname = dirname( __FILE__ ) . '/cache/' ;
			$files   = array_diff( scandir( $dirname ) , array( '.' , '..' ) ) ;
			switch ( true ) {
				case ( count( $files ) >= 200 ) :
					$cache->clean( false , 'callback_cleanCache' ) ;
					break ;
				case ( count( $files ) >= 100 ) :
					$cache->clean( false , 'callback_CacheCleaning' ) ;
					break ;
			}
			foreach( $files as $v ) {
				if ( preg_match( '#(\.php|\.cache)$#i', $v ) ) {
					@unlink( $dirname . '/' . $v ) ;
				}
			}
		}
	}
}

if ( ! function_exists('cleanCache') ) {
	function cleanCache( $file, $group )
	{
		$limit = '-3 hours' ;
		return ( date_compare( $limit , filemtime( $file ) , '>' ) && strpos( $file , md5( 'category' ) ) === false ) ? true : false ;
	}
}

if ( ! function_exists('CacheCleaning') ) {
	function CacheCleaning( $file , $group )
	{
		$define = ( defined( 'CASHE_LIMIT' ) ) ? intval( CASHE_LIMIT ) : 60 * 60 * 24 ;
		$define = intval( $define * ( 2 / 3 ) )  ;
		$limit  = '-' . $define . ' second' ;
		return ( date_compare( $limit , filemtime( $file ) , '>' ) && strpos( $file , md5( 'category' ) ) === false ) ? true : false ;
	}
}

if ( ! function_exists('convert') ) {
	function convert( $text ) {
		mb_language( 'Japanese' ) ;
		return mb_convert_encoding( $text , mb_internal_encoding() , 'UTF-8,EUC-JP,SJIS-win,JIS,ASCII' ) ;
	}
}

if ( ! function_exists('convert_to_utf') ) {
	function convert_to_utf( $text ) {
		mb_language( 'Japanese' ) ;
		return mb_convert_encoding( $text , 'UTF-8' , 'UTF-8,EUC-JP,SJIS-win,JIS,ASCII' ) ;
	}
}

if ( ! function_exists('convert_to_html_entities') ) {
	function convert_to_html_entities( $text ) {
		mb_language( 'Japanese' ) ;
		return mb_convert_encoding( $text , 'HTML-ENTITIES' , 'UTF-8,EUC-JP,SJIS-win,JIS,ASCII' ) ;
	}
}

if ( ! function_exists('entityDecode') ) {
	function entityDecode( $text , $encoding = 'UTF-8' )
	{
		switch ( version_compare( PHP_VERSION, '5.0', '>=' ) ) {
			case true :
				return html_entity_decode( $text , ENT_QUOTES , $encoding ) ;
			case false :
				return preg_replace_callback( '`(&#?[\d\w]+;)`' , 'entity_decode_callback' , $text ) ;
		}
	
	}
}

if ( ! function_exists('entity_decode_callback') ) {
	function entity_decode_callback( $matches )
	{
		return utf8_encode( html_entity_decode( $matches[1] , ENT_QUOTES ) ) ;
	}
}

if ( ! function_exists('checkJsonp') ) {
	function checkJsonp( $password , $host )
	{
		$result = 0 ;
		if ( JSONP_PASSWORD === '' || empty( $password ) ) return false ;
		if ( is_sameValue( $password, JSONP_PASSWORD ) ) $result++ ;
		$array = explode( ',', JSONP_CHECK_HOST ) ;
		foreach ( $array as $value ) {
			if ( is_sameValue( trim( $value ) , $host ) ) {
				$result++ ;
				break ;
			}
		}
		return ( $result == 2 ) ? true : false ;
	}
}

if ( ! function_exists('is_sameValue') ) {
	function is_sameValue( $str1 , $str2 )
	{
		return ( strcmp( $str1 , $str2 ) == 0 ) ? true : false ;
	}
}

if ( ! function_exists('is_digit') ) {
	function is_digit( $value )
	{
		switch ( true ) {
			case ( function_exists( 'ctype_digit' ) ) :
				return ctype_digit( (string)$value ) ;
			default:
				return (bool)preg_match( '#^[[:digit:]]+$#', $value ) ;
		}
	}
}

if ( ! function_exists('toShow') ) {
	function toShow( $arr )
	{
		if ( is_array( $arr ) ) {
			return array_map( 'toShow', $arr ) ;
		} else {
			return preg_replace( "/&amp;(#[0-9]+|#x[0-9a-f]+|[a-z]+[0-9]*);/i", '&\\1;', htmlspecialchars( $arr , ENT_QUOTES , 'UTF-8' ) ) ;
		}
	}
}

if ( ! function_exists('stripSlashesGPC') ) {
	function &stripSlashesGPC( $str )
	{
		return ( get_magic_quotes_gpc() ) ? stripslashes( $str ) : $str ;
	}
}

if ( ! function_exists('deleteControlCode') ) {
	function deleteControlCode( $str )
	{
		return preg_replace( '#[\x00-\x1f\x7f]#', '', $str ) ;
	}
}

if ( ! function_exists('replace_wave_dash') ) {
	function replace_wave_dash( $str )
	{
		if ( is_array( $str ) ) {
			return array_map( 'replace_wave_dash' , $str ) ;
		} else {
			$patterns = array(
				// 波ダッシュを全角チルダ(～)へ変換
				'/\xE3\x80\x9C/' => "\xEF\xBD\x9E",
				// 全角マイナス記号(－)の変換
				'/\xE2\x88\x92/' => "\xEF\xBC\x8D",
				// 双柱・平行記号(∥)の変換
				'/\xE2\x80\x96/' => "\xE2\x88\xA5",
				// セント記号(￠)の変換 
				'/\xC2\xA2/' => "\xEF\xBF\xA0",
				// ポンド記号(￡)の変換
				'/\xC2\xA3/' => "\xEF\xBF\xA1",
				// 否定記号(￢)の変換
				'/\xC2\xAC/' => "\xEF\xBF\xA2",
			) ;
			return preg_replace( array_keys( $patterns ) , array_values( $patterns ) , $str ) ;
		}
	}
}

if ( ! function_exists('isAjax') ) {
	function isAjax() {
		$env = ( $v = @$_SERVER['HTTP_X_REQUESTED_WITH'] ) ? strtolower( $v ) : null ;
		if ( empty( $env ) && function_exists( 'apache_request_headers' ) ) {
			$headers = array_change_key_case( apache_request_headers() , CASE_LOWER ) ;
			$env     = ( ! empty( $headers['x-requested-with'] ) && $v = $headers['x-requested-with'] ) ? strtolower( $v ) : null ;
		}
		switch ( true ) {
			case ( empty( $env ) ) :
			case ( $env !== 'xmlhttprequest' ) :
				return false ;
			default:
				return true ;
		}
	}
}

if ( ! function_exists('array_column') ) {
	function array_column( $array , $column , $index = null )
	{
		$ret    = array() ;
		$array  = ( is_array( $array ) ) ? $array : array() ;
		$column = ( isset( $column ) && is_scalar( $column ) ) ? $column : null ;
		$index  = ( isset( $index ) && is_scalar( $index ) ) ? $index : null ;
		if ( ! empty( $array ) ) switch ( true ) {
			case ( ! empty( $column ) ) :
				$i = 0 ;
				foreach ( $array as $v ) {
					if ( ! is_array( $v ) || ! array_key_exists( $column , $v ) ) continue ;
					$key_exists = isset( $index ) && array_key_exists( $index , $v ) ;
					$ret[ ( $key_exists === true ) ? $v[ $index ] : $i ] = $v[ $column ] ;
					if ( $key_exists === false ) $i++ ;
				}
				break ;
			case ( is_null( $column ) && isset( $index ) ) :
				foreach ( $array as $v ) {
					if ( is_array( $v ) && array_key_exists( $index , $v ) ) $ret[ $v[ $index ] ] = $v ;
				}
				break ;
		}
		return $ret ;
	}
}

if ( ! function_exists('preserve_keys_slice') ) {
	function preserve_keys_slice( $array , $offset , $length = null )
	{ 
		switch ( version_compare( PHP_VERSION , '5.0.2', '>=' ) ) {
			case ( true ) :
				return array_slice( $array , $offset , $length , true ) ;
			case ( false ) :
				$ret  = array();
				$keys = array_slice( array_keys( $array ) , $offset , $length ) ;
				foreach ( $keys as $key) {
					$ret[ $key ] = $array[ $key ] ;
				}
				return $ret ;
		}
	}
}

if ( ! function_exists('time_ex') ) {
	function time_ex() {
		switch ( true ) {
			case ( class_exists( 'DateTime' ) ) :
				$obj = new DateTime() ;
				return ( $v = $obj->format( 'U' ) ) ? $v : false ;
			default :
				return time() ;
		}
	}
}

if ( ! function_exists('date_ex') ) {
	function date_ex( $format = null , $value = 'now' , $gmt = false ) {
		$format = ( empty( $format ) ) ? 'Y-n-j H:i' : $format ;
		switch ( true ) {
			case ( is_digit( $value ) && class_exists( 'DateTime' ) ) :
				$obj = new DateTime( "@$value" ) ;
				if ( $gmt === false ) $obj->setTimezone( new DateTimeZone( ini_get( 'date.timezone' ) ) ) ;
				return ( $v = $obj->format( $format ) ) ? $v : false ;
			case ( class_exists( 'DateTime' ) ) :
				$obj = new DateTime( $value ) ;
				if ( $gmt === true ) $obj->setTimezone( new DateTimeZone( 'UTC' ) ) ;
				return ( $v = $obj->format( $format ) ) ? $v : false ;
			default :
				$time = ( is_digit( $value ) ) ? (int)$value : ( ( $value === 'now' ) ? time() : strtotime( $value ) ) ;
				return ( $time === false || $time === -1 ) ? false : ( ( $gmt === true ) ? gmdate( $format , $time ) : date( $format , $time ) ) ;
		}
	}
}

if ( ! function_exists('date_compare') ) {
	function date_compare( $date1 , $date2 , $operator = '<' )
	{
		switch ( true ) {
			case ( class_exists( 'DateTime' ) && version_compare( PHP_VERSION, '5.2.2' , '>=' ) ) :
				$from = ( is_digit( $date1 ) ) ? new DateTime( "@$date1" ) : new DateTime( $date1 ) ;
				$from->setTimezone( new DateTimeZone( ini_get( 'date.timezone' ) ) ) ;
				$to   = ( is_digit( $date2 ) ) ? new DateTime( "@$date2" ) : new DateTime( $date2 ) ;
				$to->setTimezone( new DateTimeZone( ini_get( 'date.timezone' ) ) ) ;
				break ;
			default :
				$from = ( is_digit( $date1 ) ) ? (int)$date1 : ( ( $date1 === 'now' ) ? time() : strtotime( $date1 ) ) ;
				$to   = ( is_digit( $date2 ) ) ? (int)$date2 : ( ( $date2 === 'now' ) ? time() : strtotime( $date2 ) ) ;
		}
		switch ( $operator ) {
			case '>' :
				return (bool)( $from > $to ) ;
			case '>=' :
				return (bool)( $from >= $to ) ;
			case '<=' :
				return (bool)( $from <= $to ) ;
			case '==' :
				return (bool)( $from == $to ) ;
			case '!=' :
				return (bool)( $from != $to ) ;
			case '<' :
				return (bool)( $from < $to ) ;
			default :
				return ;
		}
	}
}

if ( ! function_exists('json_decode') ) {
	function json_decode( $data , $assoc = false )
	{
		include_once( 'Services/JSON.php' ) ;
		$json = ( ! empty( $assoc ) ) ? new Services_JSON( SERVICES_JSON_LOOSE_TYPE ) : new Services_JSON() ;
		return $json->decode( $data ) ;
	}
}

if ( ! function_exists('json_encode') ) {
	function json_encode( $data )
	{
		include_once( 'Services/JSON.php' ) ;
		$json = new Services_JSON() ;
		return $json->encodeUnsafe( $data ) ;
	}
}

?>